//+------------------------------------------------------------------+
//|                                                 Aroon 2MA EA.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

input string StartHour   = "00:00";
input string EndHour     = "23:59";
input string AroonLocation = "aroon";
input double LotSize = 1.00;
input double TakeProfit = 400;
input double StopLoss = 300;
input bool UseTrailing = true;
input int    TrailStop    = 200;
input int    TrailStep    = 150;
input int Magic =42543;
input int MaxTrades = 5;

//input bool UseAroon = true;
//input int AroonPeriod= 9; // period of the indicator 
//input int AroonShift = 0; // horizontal shift of the indicator in bars
//input double AroonUpperLine = 70;

input bool UseMA1 = true;
input int MA1Period = 14;
input int MA1Shift = 1;
input ENUM_APPLIED_PRICE MA1Price = PRICE_CLOSE;
input ENUM_MA_METHOD MA1Method = MODE_EMA;

input bool UseMA2 = true;
input int MA2Period = 45;
input int MA2Shift = 1;
input ENUM_APPLIED_PRICE MA2Price = PRICE_CLOSE;
input ENUM_MA_METHOD MA2Method = MODE_EMA;

input bool pSARClose = true;
input double         InpSARStep=0.02;    // Step
input double         InpSARMaximum=0.2;  // Maximum

input string SleepTimerSettings = "----Sleep Timer------------";
input bool UseSleepTimer = true;
input int NumOfLoss = 3;
input int NumOfMinutes = 5;

double value1, value2, value3;
#include <Tools\DateTime.mqh>
#include<Trade\Trade.mqh>
CTrade  trade;
int BuyAroon, SellAroon, sarvalue, MA1, MA2, ma1buy, ma1sell, ma2buy, ma2sell, aroonbuy, aroonsell, tnum, nump, time_bar;
double _arb[];
double _ars[];
double _ma1[];
double _ma2[];
double sars[];
double arb, ars, ask, bid;
double tpoint;
   int closetime=0;
   int lasttime=0;
   int all, lastall=0;
   int allloss=0;
   double profit, tprofit;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   //---
   //find Point value
    tpoint=SymbolInfoDouble(Symbol(),SYMBOL_POINT);
    
   //--- set MagicNumber for your orders identification
   int MagicNumber=Magic;
   trade.SetExpertMagicNumber(MagicNumber);
   
   //--- set available slippage in points when buying/selling
   int deviation=50;
   trade.SetDeviationInPoints(deviation);
   
   //--- order filling mode, the mode allowed by the server should be used
   trade.SetTypeFilling(ORDER_FILLING_RETURN);
   
   //--- logging mode: it would be better not to declare this method at all, the class will set the best mode on its own
   trade.LogLevel(1); 
   
   //--- what function is to be used for trading: true - OrderSendAsync(), false - OrderSend()
   trade.SetAsyncMode(false);
   
   //BuyAroon=iCustom(NULL,0,AroonLocation,AroonPeriod,AroonShift);
   //SellAroon=iCustom(NULL,0,AroonLocation,AroonPeriod,AroonShift);
   MA1=iMA(NULL,0,MA1Period,MA1Shift,MA1Method,MA1Price);
   MA2=iMA(NULL,0,MA2Period,MA2Shift,MA2Method,MA2Price);
   sarvalue = iSAR(NULL,0,InpSARStep,InpSARMaximum);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---

   ScanClosedTrades();
   time_bar=TimeCurrent();
   if(IsNewCandle()){
   nump=0;
   }
   OpenOrders();
   ask=SymbolInfoDouble(Symbol(),SYMBOL_ASK);
   bid=SymbolInfoDouble(Symbol(),SYMBOL_BID);
   
   ArraySetAsSeries(sars, true);
   //if(CopyBuffer(BuyAroon,0,0,3,_arb)<0){Print("CopyBuffer1 error =",GetLastError());}
   //if(CopyBuffer(SellAroon,1,0,3,_ars)<0){Print("CopyBuffer2 error =",GetLastError());}
   if(CopyBuffer(MA1,0,0,3,_ma1)<0){Print("CopyBuffer3 error =",GetLastError());}
   if(CopyBuffer(MA2,0,0,3,_ma2)<0){Print("CopyBuffer4 error =",GetLastError());}
   if(CopyBuffer(sarvalue,0,0,20,sars)<0){Print("CopyBuffer5 error =",GetLastError());}
   Comment(_ma1[0], "  ", _ma1[2]);
   //Comment(_arb[1], "  ", sars[1], "  ", _ma1[1], "  ", _ma2[1]);
   FindSignals();
      if(pSARClose==true){SARClose();}
   if(UseTrailing==true){Trailing();}
  }
//+------------------------------------------------------------------+


void FindSignals(){
if(UseMA1==true){
   if(ask>_ma1[1]){ma1buy=1;}else{ma1buy=0;}
   if(ask<_ma1[1]){ma1sell=1;}else{ma1sell=0;}
   }else{ma1buy=1;ma1sell=1;}

if(UseMA2==true){
   if(ask>_ma2[1]){ma2buy=1;}else{ma2buy=0;}
   if(ask<_ma2[1]){ma2sell=1;}else{ma2sell=0;}
   }else{ma2buy=1;ma2sell=1;}

//if(UseAroon==true){
//   if(_arb[1]>AroonUpperLine){aroonbuy=1;}else{aroonbuy=0;}
//   if(_ars[1]>AroonUpperLine){aroonsell=1;}else{aroonsell=0;}
//   }else{
//   aroonbuy=1;
//   aroonsell=1;
//   }

   if(ma1buy==1 && ma2buy==1 && tnum<MaxTrades && nump==0 && WorkingHour()==true){
   
   double sl= (ask-(StopLoss*tpoint));
   double tp= (ask+(TakeProfit*tpoint));
      trade.Buy(LotSize,Symbol(),ask,sl,tp,"PZ Day Trade");
      //Buy
      nump=1;
   }
   
  if(ma1sell==1 && ma2sell==1 && tnum<MaxTrades && nump==0 && WorkingHour()==true){
   
   double sl= (bid+(StopLoss*tpoint));
   double tp= (bid-(TakeProfit*tpoint));
      trade.Sell(LotSize,Symbol(),bid,sl,tp,"PZ Day Trade");
      //Sell
      nump=1;
   }
}

void OpenOrders(){
   tnum =0;
   int _tp=PositionsTotal();
   for(int i=_tp-1; i>=0; i--)
     {
      string _p_symbol=PositionGetSymbol(i);
      if(_p_symbol==_Symbol){
      if(Magic==PositionGetInteger(POSITION_MAGIC)){
      
      //---
         tnum++;
   
      }
   }

}
}

//+------------------------------------------------------------------+
//insuring its a new candle function
//+------------------------------------------------------------------+
bool IsNewCandle()
{
   static int BarsOnChart=0;
	if (Bars(_Symbol,PERIOD_CURRENT) == BarsOnChart)
	return (false);
	BarsOnChart = Bars(_Symbol,PERIOD_CURRENT);
	return(true);
}

bool WorkingHour() {
  datetime gi_time_01 = StringToTime(TimeToString(TimeCurrent(), TIME_DATE) + " " + StartHour);
  datetime gi_time_02 = StringToTime(TimeToString(TimeCurrent(), TIME_DATE) + " " + EndHour);
  datetime datetime_0 = TimeCurrent();
  
  if( gi_time_01 < gi_time_02 && gi_time_01 <= datetime_0 && datetime_0 <= gi_time_02 ) return (true);
  if( gi_time_01 > gi_time_02 && (datetime_0 >= gi_time_01 || datetime_0 <= gi_time_02) ) return (true);
    
    
  return (false);
}

void Trailing(){
double newsl;
   int _tp=PositionsTotal();
   for(int i=_tp-1; i>=0; i--)
     {
     string _p_symbol=PositionGetSymbol(i);
     double _p_tp = PositionGetDouble(POSITION_TP);
     double _p_sl = PositionGetDouble(POSITION_SL);
     double _p_op = PositionGetDouble(POSITION_PRICE_OPEN);
     long _p_type = PositionGetInteger(POSITION_TYPE);
     
     if(_p_symbol==_Symbol && _p_type==POSITION_TYPE_BUY && ((ask-_p_op)>TrailStop*tpoint)){
     newsl=ask-(TrailStep*tpoint);
     if(newsl>_p_sl && newsl!=_p_sl){
     trade.PositionModify(_Symbol,newsl,_p_tp);
     }
     }
     
     if(_p_symbol==_Symbol && _p_type==POSITION_TYPE_SELL && (_p_op-bid>TrailStop*tpoint)){
     newsl=bid+(TrailStep*tpoint);
     if((_p_sl>newsl||_p_sl==0) && newsl!=_p_sl){
     trade.PositionModify(_Symbol,newsl,_p_tp);
     }
     }
   }
}


void SARClose(){
   
   if(bid>sars[1] && nump==0){CLOSESELL();}
   if(bid<sars[1] && nump==0){CLOSEBUY();}
}

void CLOSEBUY(){
   int _tp=PositionsTotal();
   for(int i=_tp-1; i>=0; i--)
     {
      string _p_symbol=PositionGetSymbol(i);
     
      if(_p_symbol==_Symbol){
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY){
         trade.PositionClose(PositionGetInteger(POSITION_TICKET),-1);
         }
      }
    }
  }
  
    void CLOSESELL(){
   int _tp=PositionsTotal();
   for(int i=_tp-1; i>=0; i--)
     {
      string _p_symbol=PositionGetSymbol(i);
      
      if(_p_symbol==_Symbol){
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL){
         trade.PositionClose(PositionGetInteger(POSITION_TICKET),-1);
      }
    }
  }
}


void ScanClosedTrades()
{
  HistorySelect(0,TimeCurrent());
   int time = NumOfMinutes*60000;
   
   ulong  ticket = 0;

   uint   dealsTotal=HistoryDealsTotal(); 
 //--- Loop for tracking wins losses and lot sizes for trading
        
         for (uint i=0; i < dealsTotal; i++)
               {
                if((ticket=HistoryDealGetTicket(i))>0)
                {
                profit=HistoryDealGetDouble(ticket,DEAL_PROFIT);
                closetime=HistoryDealGetInteger(ticket,DEAL_TIME);
                }
               
                if (HistoryDealGetString(ticket,DEAL_SYMBOL)==_Symbol && closetime>lasttime)
                  {
                     Print("Profit: %f",profit);//profit);
                     all++;
                     allloss++;
                     lasttime=closetime;
                     tprofit=profit;
                  }
               }
     
     
     if(tprofit>0.01){value3=1;}
     //value1=profit;
     
if(UseSleepTimer==true){
     if(tprofit<-0.1 && tprofit!=value2){
      
      lastall=allloss;
      value3++;
      value2=tprofit;
     // Comment("not yet");
     //Comment(tprofit, " ", value3, " ", lastall);
     if(value3==(NumOfLoss+1)){
      
      Comment(" Sleep ");
      Sleep(time);
      value3=0;
      }
     }
   }
}